#pragma once

#include <stdint.h>
#include <pthread.h>

#define TOPO_MAX_CHILDREN (256)

struct topo_desc {
    struct topo_obj * root;
    int core_to_numa_lookup[TOPO_MAX_CHILDREN];
    int num_core;
    int num_numa;

    // ts
    uint64_t tsc_freq;
};

int
topo_ts_init(struct topo_desc *desc, int verbose);

uint64_t
topo_desc_uptime_ns(struct topo_desc * desc);
